<script setup>
import { toast } from 'bulma-toast'

const router = useRouter()
const activeSave = useActiveSave()

definePageMeta({
  middleware: ['auth', 'org']
})

const client = useCookie('logship_client')
const clientId = useCookie('logship_client_id')
const organization = useCookie('logship_organization')
const organizationId = useCookie('logship_organization_id')

const form = ref({
  id: '',
  uid: '',
  client: client.value?.Name || '',
  clientId: clientId.value || '',
  organization: organization.value?.Name || '',
  organizationId: organizationId.value || '',
  name: '',
  description: '',
  isActive: true,
  isDefault: false,
  stdPrecision: 2,
  costingPrecision: 0,
  uomSymbol: '',
  uomCode: '',
  UNCEFACT: '',
  uomType: '',
  uomTypeId: '',
  processing: false,
  alert: {
    status: '',
    message: '',
    processing: false
  }
})

const back = () => {
  if(activeSave.value) {
    toast({
      message: 'Save button is active, please submit the data before leaving!',
      type: 'is-warning',
      duration: 2000
    })
  } else {
    router.push('/materials/stock-units')
  }
}

const save = async (record) => {
  form.value = record
  
  if(form.value.name !== '' && form.value.stdPrecision !== '' && form.value.costingPrecision !== '' && form.value.uomCode !== '') {
    activeSave.value = true
  } else {
    activeSave.value = false
  }
}

const submit = async (saveType = '') => {
  form.value.alert.processing = true
  activeSave.value = true

  const res = await $fetch('/api/materials/stock-units/store', {
    method: 'POST',
    headers: useRequestHeaders(['cookie']),
    body: {
      organizationId: form.value.organizationId,
      name: form.value.name,
      description: form.value.description,
      isActive: form.value.isActive,
      isDefault: form.value.isDefault,
      stdPrecision: form.value.stdPrecision,
      costingPrecision: form.value.costingPrecision,
      uomSymbol: form.value.uomSymbol,
      uomCode: form.value.uomCode,
      UNCEFACT: form.value.UNCEFACT,
      uomTypeId: form.value.uomTypeId,
    }
  })

  if(Number(res.status) === 200) {
    form.value.alert.processing = false
    activeSave.value = false
    
    if(saveType === 'preview') {
      router.push('/materials/stock-units/' + res.id + '/view')
    } else if(saveType === 'changes' || saveType === 'onlysave') {
      router.push('/materials/stock-units/'+res.id+'/edit')
      toast({
        message: 'Saved!',
        type: 'is-success',
        duration: 2000
      })
    } else {
      back()
    }
  } else {
    //form.value.alert.status = res.status
    //form.value.alert.message = res.message
    form.value.alert.processing = false
    activeSave.value = false
    toast({
      message: res.message || 'Save error',
      type: 'is-danger',
      duration: 2000
    })
    //window.scrollTo(0, 0)
  }
}

const breadCrumb = computed(() => ([
  { link: '#', text: 'Materials'},
  { link: '/materials/stock-units', text: 'Stock Units'},
  { link: '#', text: 'Add Stock Unit', active: true}
]))
</script>

<template>
  <Head>
    <Title>Add Stock Unit</Title>
  </Head>

  <NuxtLayout name="new-dash">
    <NewBreadCrumb :items="breadCrumb" />

    <div class="bannercontrol">
      <div class="d-flex gap-10px">
        <button type="button" @click="submit('onlysave')" class="button" :class="(form.name === '' || form.stdPrecision === '' || form.costingPrecision === '' || form.uomCode === '' || form.alert.processing) ? 'pointerEvents-none opacity-0.6' : ''">Save</button>
      </div>
      <div>
        <div class="d-flex gap-10px">
          <button v-if="activeSave" type="button" @click="activeSave = false; back();" class="button">
            <span class="tf-icon ti ti-square-x ti-xs me-1 color-inherit"></span> Abort
          </button>
          <button type="button" @click="back" class="button">
            <span class="tf-icon ti ti-chevron-left ti-xs me-1 color-inherit"></span> Back
          </button>
        </div>
      </div>
    </div>

    <div>
      <div class="banner">
        <div>
          <MaterialsStockUnitForm v-model="form" @save="save"/>
        </div>
        <div class="opacity-0.6 pointerEvents-none">
          <MaterialsStockUnitDetailRecord action="create" :info="form" />
        </div>
      </div>
    </div>
  </NuxtLayout>
</template>